var ActionFunctionRegistry = /** @class */ (function () {
    function ActionFunctionRegistry() {
        this.functionRegistry = {};
    }
    ActionFunctionRegistry.prototype.register = function (name, func, thisArg) {
        if (thisArg === void 0) { thisArg = null; }
        if (this.functionRegistry[name]) {
            throw new Error("Function already registered!");
        }
        this.functionRegistry[name] = { func: func, thisArg: thisArg };
    };
    ActionFunctionRegistry.prototype.getFunctionByName = function (name) {
        if (!this.functionRegistry[name]) {
            throw new Error("Function not defined/registered");
        }
        return this.functionRegistry[name];
    };
    return ActionFunctionRegistry;
}());
export { ActionFunctionRegistry };
//# sourceMappingURL=ActionFunctionRegistry.js.map