/** Mitt: Tiny (~200b) functional event emitter / pubsub.
 *  @name mitt
 *  @returns {Mitt}
 */
export default function mitt(all) {
    all = all || Object.create(null);
    return {
        on: function (type, handler) {
            (all[type] || (all[type] = [])).push(handler);
        },
        off: function (type, handler) {
            if (all[type])
                all[type].splice(all[type].indexOf(handler) >>> 0, 1);
        },
        emit: function (type, evt) {
            (all[type] || []).slice().map(function (handler) {
                handler(evt);
            });
        }
    };
}
//# sourceMappingURL=Mitt.js.map