"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ActionFunctionRegistry = /** @class */ (function () {
    function ActionFunctionRegistry() {
        this.functionRegistry = {};
    }
    ActionFunctionRegistry.prototype.register = function (name, func, thisArg) {
        if (thisArg === void 0) { thisArg = null; }
        if (this.functionRegistry[name]) {
            throw new Error("Function already registered!");
        }
        this.functionRegistry[name] = { func: func, thisArg: thisArg };
    };
    ActionFunctionRegistry.prototype.getFunctionByName = function (name) {
        if (!this.functionRegistry[name]) {
            console.log(this.functionRegistry);
            throw new Error("Function not defined/registered " + name);
        }
        return this.functionRegistry[name];
    };
    ActionFunctionRegistry.prototype.isPresent = function (name) {
        if (this.functionRegistry[name])
            return true;
        return false;
    };
    return ActionFunctionRegistry;
}());
exports.ActionFunctionRegistry = ActionFunctionRegistry;
//# sourceMappingURL=ActionFunctionRegistry.js.map