"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/** Mitt: Tiny (~200b) functional event emitter / pubsub.
 *  @name mitt
 *  @returns {Mitt}
 */
var Mitt = /** @class */ (function () {
    function Mitt(all) {
        this.all = this.all || Object.create(null);
    }
    Mitt.prototype.on = function (type, handler, ctx) {
        if (ctx === void 0) { ctx = null; }
        if (ctx)
            (this.all[type] || (this.all[type] = [])).push(handler.bind(ctx));
        else
            (this.all[type] || (this.all[type] = [])).push(handler);
    };
    Mitt.prototype.off = function (type, handler) {
        if (this.all[type])
            this.all[type].splice(this.all[type].indexOf(handler) >>> 0, 1);
    };
    Mitt.prototype.emit = function (type) {
        var evt = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            evt[_i - 1] = arguments[_i];
        }
        (this.all[type] || []).slice().map(function (handler) {
            handler.apply(void 0, evt);
        });
    };
    return Mitt;
}());
exports.Mitt = Mitt;
//# sourceMappingURL=Mitt.js.map