var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { isReversibleAction } from "./Actions";
import { isStateNode } from "./Node";
function isNextNodeInTrackUp(currentNode, nextNode) {
    if (isStateNode(currentNode) && currentNode.parent === nextNode) {
        return true;
    }
    else if (isStateNode(nextNode) && nextNode.parent !== currentNode) {
        throw new Error("Unconnected nodes. Illegal use of function.");
    }
    else {
        return false;
    }
}
function findPathToTargetNode(currentNode, targetNode, track, comingFromNode) {
    if (comingFromNode === void 0) { comingFromNode = currentNode; }
    if (currentNode && currentNode === targetNode) {
        track.unshift(currentNode);
        return true;
    }
    else if (currentNode) {
        var nodesToCheck = currentNode.children.slice();
        if (isStateNode(currentNode)) {
            nodesToCheck.push(currentNode.parent);
        }
        for (var _i = 0, nodesToCheck_1 = nodesToCheck; _i < nodesToCheck_1.length; _i++) {
            var node = nodesToCheck_1[_i];
            // If already in track, skip
            if (node === comingFromNode)
                continue;
            if (findPathToTargetNode(node, targetNode, track, currentNode)) {
                track.unshift(currentNode);
                return true;
            }
        }
    }
    eval("console").log(track);
    return false;
}
function executeFunctions(functionsToDo, argumentsToDo) {
    return __awaiter(this, void 0, void 0, function () {
        var result, i, funcWithThis;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < functionsToDo.length)) return [3 /*break*/, 4];
                    funcWithThis = functionsToDo[i];
                    return [4 /*yield*/, funcWithThis.func.apply(funcWithThis.thisArg, argumentsToDo[i])];
                case 2:
                    result = _a.sent();
                    _a.label = 3;
                case 3:
                    ++i;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, result];
            }
        });
    });
}
var ProvenanceGraphTraverser = /** @class */ (function () {
    function ProvenanceGraphTraverser(registry, graph) {
        this.registry = registry;
        this.graph = graph;
    }
    ProvenanceGraphTraverser.prototype.toStateNode = function (id) {
        var _this = this;
        try {
            var currentNode = this.graph.current;
            var targetNode_1 = this.graph.getNode(id);
            if (currentNode === targetNode_1) {
                return Promise.resolve(currentNode);
            }
            var trackToTarget = [];
            var success = findPathToTargetNode(currentNode, targetNode_1, trackToTarget);
            if (!success) {
                throw new Error("No path found");
            }
            var functionsToDo = [];
            var argumentsToDo = [];
            for (var i = 0; i < trackToTarget.length - 1; ++i) {
                var thisNode = trackToTarget[i];
                var nextNode = trackToTarget[i + 1];
                var up = isNextNodeInTrackUp(thisNode, nextNode);
                if (up) {
                    if (isStateNode(thisNode)) {
                        if (!isReversibleAction(thisNode.action)) {
                            throw new Error("Cannot undo an irreversible action");
                        }
                        var undoFunc = this.registry.getFunctionByName(thisNode.action.undo);
                        functionsToDo.push(undoFunc);
                        argumentsToDo.push(thisNode.action.undoArguements);
                    }
                    else {
                        throw new Error("At root node now! Cannot go further back!");
                    }
                }
                else {
                    if (isStateNode(nextNode)) {
                        var doFunc = this.registry.getFunctionByName(nextNode.action.do);
                        functionsToDo.push(doFunc);
                        argumentsToDo.push(nextNode.action.doArguments);
                    }
                    else {
                        throw new Error("At root! unreachable!");
                    }
                }
            }
            var result = executeFunctions(functionsToDo, argumentsToDo);
            result.then(function () { return (_this.graph.current = targetNode_1); });
            return result;
        }
        catch (err) {
            return Promise.reject(err);
        }
    };
    return ProvenanceGraphTraverser;
}());
export { ProvenanceGraphTraverser };
//# sourceMappingURL=ProvenanceGraphTraverser.js.map