"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
var ProvenanceGraphTraverser_1 = require("./Provenance/ProvenanceGraphTraverser");
var ProvenanceTracker_1 = require("./Provenance/ProvenanceTracker");
var Command_1 = require("./Command/Command");
var ViewModelBase = /** @class */ (function () {
    function ViewModelBase(view, app) {
        this.comm = view.comm;
        this._uuid = _1.generateFunctionUUID();
        this.App = app;
        this.tracker = new ProvenanceTracker_1.ProvenanceTracker(this.registry, app.graph);
        this.traverser = new ProvenanceGraphTraverser_1.ProvenanceGraphTraverser(this.registry, app.graph);
        this.comm.emit("create");
        this.App.on("graph-loaded", this.load, this);
    }
    Object.defineProperty(ViewModelBase.prototype, "registry", {
        get: function () {
            return this.App.registry;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ViewModelBase.prototype, "graph", {
        get: function () {
            return this.App.graph;
        },
        enumerable: true,
        configurable: true
    });
    ViewModelBase.prototype.apply = function (args) {
        Command_1.apply.call.apply(Command_1.apply, [this].concat(args));
    };
    ViewModelBase.prototype.registerFunctions = function (str, func, thisArg, _do) {
        if (_do === void 0) { _do = true; }
        if (_do)
            this.App.registry.register("do_" + str, func, thisArg);
        else
            this.App.registry.register("undo_" + str, func, thisArg);
    };
    ViewModelBase.prototype.load = function (graph) {
        this.App.graph = graph;
        this.tracker = new ProvenanceTracker_1.ProvenanceTracker(this.registry, this.App.graph);
        this.traverser = new ProvenanceGraphTraverser_1.ProvenanceGraphTraverser(this.registry, this.App.graph);
    };
    return ViewModelBase;
}());
exports.ViewModelBase = ViewModelBase;
//# sourceMappingURL=ViewModelBase.js.map