import { StateNode } from "./Node";
import { Action } from "./Actions";
/**
 * String identifier for nodes.
 */
export declare type NodeIdentifier = string;
export declare type NodeMetadata = {
    createdBy: string;
    createdOn: number;
    [key: string]: any;
};
/**
 * Attached to nodes
 */
export declare type Artifacts = {
    [key: string]: any;
};
/**
 * Basic type of node.
 */
export declare type RootNode = {
    id: NodeIdentifier;
    label: string;
    metadata: NodeMetadata;
    children: StateNode[];
    artifacts: Artifacts;
};
export declare type StateNode = RootNode & {
    action: Action;
    actionResult: any;
    parent: ProvenanceNode;
};
export declare type ProvenanceNode = RootNode | StateNode;
export declare function isStateNode(node: ProvenanceNode): node is StateNode;
