/**
 * Action can be either reversible or irreversible
 */
export declare type Action = IrreversibleAction | ReversibleAction;
/**
 * * Metadata for Actions
 */
export declare type ActionMetadata = {
    /**
     * List of tags for the action.
     */
    tags?: string[];
    /**
     * The intent of user to trigger the action.
     */
    userIntent?: string;
    /**
     * Custom properties
     */
    [key: string]: any;
};
export declare type IrreversibleAction = {
    metadata?: ActionMetadata;
    do: string;
    doArguments: any[];
};
export declare type ReversibleAction = IrreversibleAction & {
    undo: string;
    undoArguements: any[];
};
export declare type ActionFunction = (...args: any[]) => Promise<any>;
export declare type ActionFunctionWithThis = {
    func: ActionFunction;
    thisArg: any;
};
export declare function isReversibleAction(action: Action): action is ReversibleAction;
