import { SerializedProvenanceGraph } from "./Serialized";
import { Handler } from "./Handler";
import { RootNode, ProvenanceNode, NodeIdentifier } from "./Node";
import { Application } from "./Application";
import { IProvenanceGraph } from "./IProvenanceGraph";
export declare class ProvenanceGraph implements IProvenanceGraph {
    application: Application;
    readonly root: RootNode;
    private _current;
    private _mitt;
    private _nodes;
    constructor(application: Application, userid?: string, rootNode?: RootNode);
    addNode(node: ProvenanceNode): void;
    getNode(id: NodeIdentifier): ProvenanceNode;
    current: ProvenanceNode;
    readonly nodes: {
        [key: string]: ProvenanceNode;
    };
    emitNodeChangedEvent(node: ProvenanceNode): void;
    on(type: string, handler: Handler): void;
    off(type: string, handler: Handler): void;
    static restoreProvenanceGraph(serializedGraph: SerializedProvenanceGraph): ProvenanceGraph;
    static serializeProvenanceGraph(graph: ProvenanceGraph): SerializedProvenanceGraph;
}
