import { Application } from "./Application";
import { Action } from "./Actions";
import { NodeIdentifier, NodeMetadata, Artifacts } from "./Node";
export declare type SerializedProvenanceGraph = {
    nodes: SerializedProvenanceNode[];
    root: NodeIdentifier;
    application: Application;
    current: NodeIdentifier;
};
export declare type SerializedRootNode = {
    id: NodeIdentifier;
    children: NodeIdentifier[];
    label: string;
    metadata: NodeMetadata;
    artifacts: Artifacts;
};
export declare type SerializedStateNode = SerializedRootNode & {
    parent: NodeIdentifier;
    action: Action;
    actionResult: any;
};
export declare type SerializedProvenanceNode = SerializedStateNode | SerializedRootNode;
