import { Handler } from "./Provenance/Handler";
import { IProvenanceGraph } from "./Provenance/IProvenanceGraph";
import { IProvenanceGraphTraverser } from "./Provenance/IProvenanceGraphTraverser";
import { IProvenanceTracker } from "./Provenance/IProvenanceTracker";
import { IActionFunctionRegistry } from "./Provenance/IActionFunctionRegistry";
import { Application } from "./Application";
import { Mitt } from "./Provenance/Mitt";
import { IView } from "./IView";
import { IViewModel } from "./IViewModel";
export declare class ViewModelBase implements IViewModel {
    App: Application;
    tracker: IProvenanceTracker;
    traverser: IProvenanceGraphTraverser;
    _uuid: string;
    comm: Mitt;
    readonly registry: IActionFunctionRegistry;
    readonly graph: IProvenanceGraph;
    constructor(view: IView, app: Application);
    apply(args: any): void;
    protected registerFunctions(str: string, func: Handler, thisArg: any, _do?: boolean): void;
    protected load(graph: IProvenanceGraph): void;
}
