import { Mitt } from "./Provenance/Mitt";
import { ActionFunctionRegistry } from "./Provenance/ActionFunctionRegistry";
import { IActionFunctionRegistry } from "./Provenance/IActionFunctionRegistry";
import { ProvenanceGraph } from "./Provenance/ProvenanceGraph";
import { IProvenanceGraph } from "./Provenance/IProvenanceGraph";
import { IViewModel } from "./IViewModel";

export class Application extends Mitt {
  name: string;
  version: string;
  viewmodels: IViewModel[];
  graph: IProvenanceGraph;
  registry: IActionFunctionRegistry;

  constructor(name: string, version: string) {
    super();
    this.name = name;
    this.version = version;
    this.viewmodels = [];
    this.registry = new ActionFunctionRegistry();
    this.graph = new ProvenanceGraph({
      name: this.name,
      version: this.version
    });
  }
}
