import { StateNode } from "./../Provenance/Node";
import { ViewModelBase } from "./../ViewModelBase";
import { ICommand } from "./ICommand";

export async function apply(
  this: ViewModelBase,
  name: string,
  _do: ICommand,
  _undo: ICommand,
  skipFirst: boolean = false
): Promise<StateNode> {

  let fn = name;

  // let dofn = `do_${fn}_${this._uuid}`;
  // let undofn = `undo_${fn}_${this._uuid}`;

  let dofn = `do_${fn}`;
  let undofn = `undo_${fn}`;

  if (!this.registry.isPresent(dofn)) {
    this.registry.register(dofn, _do.func, this);
    this.registry.register(undofn, _undo.func, this);
  }
  let res = await this.tracker.applyAction(
    {
      do: dofn,
      doArguments: _do.args,
      undo: undofn,
      undoArguements: _undo.args
    },
    skipFirst
  );
  return res;
}
