import { Handler } from "./Handler";

/** Mitt: Tiny (~200b) functional event emitter / pubsub.
 *  @name mitt
 *  @returns {Mitt}
 */

export class Mitt {
  all: any;

  constructor(all?: any) {
    this.all = this.all || Object.create(null);
  }

  on(type: string, handler: Handler, ctx: any = null) {
    if (ctx) (this.all[type] || (this.all[type] = [])).push(handler.bind(ctx));
    else (this.all[type] || (this.all[type] = [])).push(handler);
  }

  off(type: string, handler: Handler) {
    if (this.all[type])
      this.all[type].splice(this.all[type].indexOf(handler) >>> 0, 1);
  }

  emit(type: string, ...evt: any[]) {
    (this.all[type] || []).slice().map((handler: Handler) => {
      handler(...evt);
    });
  }
}
