import { StateNode } from "./../Provenance/Node";
import { ICommand } from "./../Command/ICommand";
import { Application } from "./../Application";
import { IView } from "./../IView";
import { ViewModelBase } from "./../ViewModelBase";
import { apply } from "../index";

export class TestViewModel extends ViewModelBase {
  test: string[] = ["Hello"];
  constructor(view: IView, app: Application) {
    super(view, app);
    console.log("UUID: ", this._uuid);
  }

  add(val: string): Promise<StateNode> {
    let _do: ICommand = {
      func: (val: string) => {
        this.test.push(val);
      },
      args: [val]
    };

    let _undo: ICommand = {
      func: (val: string) => {
        this.test.pop();
      },
      args: [val]
    };

    return apply.call(this, ...["add", _do, _undo]);
  }
}
