import { RootNode, StateNode, ProvenanceNode } from "./../Provenance/Node";
import { Application } from "../Application";
import { TestViewModel } from "./TestViewModel";
import { TestView } from "./TestView";
import { expect } from "chai";
import "mocha";

import * as Test from "../index";

import { IView } from "../index";

let app = new Application("Test Application", "1.0.0");
let a: any = "Test";

let vm = new TestViewModel(new TestView(<HTMLElement>a), app);
let vm2 = new TestViewModel(new TestView(<HTMLElement>a), app);

describe("Test Provenance graph with multiple models", () => {
  let a: Promise<StateNode>;
  let b: Promise<StateNode>;

  a = vm.add("Added to 1");
  Promise.resolve(a).then((a: StateNode) => {
    console.log(vm.test);
    console.log(vm2.test);
    b = vm2.add("Added to 2");
    Promise.resolve(b).then((b: StateNode) => {
      console.log(vm.test);
      console.log(vm2.test);
      let t = vm.traverser.toStateNode(a.parent.id);
      Promise.resolve(t).then((t: ProvenanceNode) => {
        console.log(vm.test);
        console.log(vm2.test);
        let p = vm.traverser.toStateNode(b.id);
        Promise.resolve(p).then(p => {
          console.log(vm.test);
          console.log(vm2.test);
        });
      });
    });
  });
});
